base/urls.py
from django.urls import path
from django.conf import settings
from django.conf.urls.static import static
from base.views import *

app_name = 'base'

urlpatterns = [
    path('', home, name='home'),
    path('faq/', faq, name='faq'),
    path('contacts/', contact, name='contacts'),
    path('about-us/', about, name='about'),
    path('investments/', investments, name='investments'),
    path('past_projects/', past_projects, name='past_projects'),
    path('investment/<str:name>', investment, name='investment'),
    path('investment_form/<str:invest>', investment_form, name='investment_form'),
    path('choose_payment/<int:invest>', choose_payment, name='choose_payment'),
    path('my_transactions/', my_transactions, name='my_transactions'),
    path('my_investments/', my_investments, name='my_investments'),
    path('delete_investment/<int:id>', delete_investment, name='delete_investment'),
    path('user_question/', question_through_email, name='question_through_email'),
]
urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

payment/urls.py
from django.urls import path
from payment.views import checkout, charge, confirm_transaction, thankyou

app_name = 'payment'

urlpatterns = [
    path('checkout/', checkout, name='checkout'),
    path('charge/<int:invest>', charge, name='charge'),
    path('payment_check/', confirm_transaction, name='payment_check'),
    path('thankyou/', thankyou, name='thankyou')
]

solomartel/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static


urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('base.urls'), name='base'),
    path('accounts/', include('accounts.urls'), name='accounts'),
    path('payment/', include('payment.urls'), name='payments')
]

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

payment/models.py
from django.db import models
from base.models import Client, Investment

# Create your models here.


STATUS = (
    ('approved', 'approved'),
    ('not_approved', 'not approved')
)


class PaymentMethod(models.Model):
    name = models.CharField(max_length=255)

    def __str__(self):
        return self.name


class UserPaymentMethod(models.Model):  # Association table (Have) between Client and PaymentMethod
    client = models.ForeignKey(Client, on_delete=models.CASCADE, related_name='my_payments_methods')
    payment_method = models.ForeignKey(PaymentMethod, on_delete=models.CASCADE)

    def __str__(self):
        return f'Client {self.client.legal_name} can pay with {self.payment_method.name}'


class Transation(models.Model):  # Association table between Client and Investment
    client = models.ForeignKey(Client, on_delete=models.CASCADE, related_name='my_transactions')
    investment = models.ForeignKey(Investment, on_delete=models.CASCADE, related_name='my_investors')
    payment_method = models.ForeignKey(PaymentMethod, on_delete=models.DO_NOTHING)
    status = models.CharField(max_length=255, choices=STATUS)
    money_spend = models.DecimalField(max_digits=10, decimal_places=2, verbose_name='Money Spend ($)')
    date = models.DateField(auto_now_add=True)

    def __str__(self):
        return f'{self.client.legal_name}  invest on  {self.investment.name}'

payment/views.py
from django.conf import settings
from accounts.models import User
from accounts.models import Client
from django.contrib import messages
from django.core.mail import send_mail
from base.models import Client_Investment
from django.template.loader import render_to_string
from django.shortcuts import render, redirect, reverse
from django.contrib.auth.decorators import login_required
from django.contrib.sites.shortcuts import get_current_site

import stripe
import secrets
import traceback

stripe.api_key = settings.STRIPE_SECRET_KEY


# Create your views here.
@login_required
def checkout(request):
    context = {'key': settings.STRIPE_PUBLISHABLE_KEY}
    return render(request, 'payment_template.html', context)


# May be protected by some decorators
# Must include robust error handling
# Create transaction for all actions required in db after charge's payment.
@login_required
def charge(request, invest):
    id_offer_obj = invest
    obj_invest = Client_Investment.objects.get(id=id_offer_obj)

    context = {}
    if request.method == 'POST':
        # retrieve associated customer, and make charge
        try:
            creditcardnumber = request.POST.get('creditcardnumber')
            exp_month = request.POST.get('month_year')
            month_year = exp_month.split('/')
            exp_month = month_year[0]

            # print("\n" * 3)
            # print("month_year is ------->", month_year)

            cardcode = request.POST.get('cardcode')
            amount = request.POST.get('amount_entered')
            # print(amount)
            exp_year = month_year[1]
            token = stripe.Token.create(
                card={
                    "number": str(creditcardnumber).replace(' ', ''),
                    "exp_month": int(exp_month),
                    "exp_year": int(exp_year) + 2000,
                    "cvc": str(cardcode)
                },
            )
            charge = stripe.Charge.create(
                amount=int(eval(amount))*100,
                currency='usd',
                description='A solomartel investment',
                source=token
            )
            if charge['paid']:
                # letters = string.ascii_lowercase + string.ascii_uppercase + string.digits
                # payment_token = ''.join(random.choice(letters) for _ in range(10))
                payment_token = secrets.token_hex(64)
                obj_invest.payment_token = payment_token
                obj_invest.done = True
                obj_invest.save()

                site_url = get_current_site(request)
                site_url = str(site_url)
                # user_id = request.user.id
                email = request.user.email
                client = Client.objects.get(user=request.user)
                subject = 'Request For Approval'
                message = ""
                email_from = settings.EMAIL_HOST_USER
                recipient_list = ['info@solomartel.com']
                html_message = render_to_string('payment/approval.html',
                                                {'client_obj': client, 'email': email, 'payment_token':
                                                    payment_token, 'investoment_id': obj_invest.id,
                                                 'site_url': site_url})
                send_mail(subject, message, f'Solomartel Holdings<{email_from}>', recipient_list,
                          html_message=html_message, fail_silently=False)
                # client.payment_done = True,
                client.payment_token = payment_token
                client.save()

                return redirect(reverse('payment:thankyou'))
        except stripe.error.CardError as e:
            traceback.print_exc()
            context = {
                'status': e.http_status,
                'error': e.error.type,
                'code': e.error.code,
                'param': e.error.param,
                'message': e.error.message,
                'obj_invest': obj_invest,
                'id_offer_obj': id_offer_obj
            }
            return render(request, 'payment/credit_card.html', context)
        except stripe.error.RateLimitError:
            traceback.print_exc()
            context = {
                'error': 'RatelimitError',
                'message': 'Too many requests made to the API too quickly',
                'obj_invest': obj_invest,
                'id_offer_obj': id_offer_obj
            }
            return render(request, 'payment/credit_card.html', context)
        except stripe.error.InvalidRequestError:
            traceback.print_exc()
            context = {
                'error': 'InvalidRequestError',
                'obj_invest': obj_invest,
                'id_offer_obj': id_offer_obj,
                'message': 'Invalid parameters were supplied to Stripe\'s API'
            }
            return render(request, 'payment/credit_card.html', context)
        except stripe.error.AuthenticationError:
            traceback.print_exc()
            context = {
                'error': 'AuthenticationError',
                'message': 'Authentication with Stripe\'s API failed',
                'obj_invest': obj_invest,
                'id_offer_obj': id_offer_obj
            }
            return render(request, 'payment/credit_card.html', context)
        except stripe.error.APIConnectionError:
            traceback.print_exc()
            context = {
                'error': 'APIConnectionError',
                'message': 'Network communication with Stripe failed',
                'obj_invest': obj_invest,
                'id_offer_obj': id_offer_obj
            }
            return render(request, 'payment/credit_card.html', context)
        except Exception as e:
            traceback.print_exc()
            context = {
                'error': 'StripeError',
                'message': 'Something went wrong, check your email',
                'obj_invest': obj_invest,
                'id_offer_obj': id_offer_obj
            }
            return render(request, 'payment/credit_card.html', context)
        except Exception:
            traceback.print_exc()
            context = {
                'error': 'Exception',
                'message': 'An error occured',
                'obj_invest': obj_invest,
                'id_offer_obj': id_offer_obj
            }
            return render(request, 'payment/credit_card.html', context)

    id_offer_obj = invest
    obj_invest = Client_Investment.objects.get(id=id_offer_obj)
    context['obj_invest'] = obj_invest
    context['id_offer_obj'] = id_offer_obj
    return render(request, 'payment/credit_card.html', context)


def thankyou(request):
    return render(request, 'payment/thankyou.html')


def confirm_transaction(request):
    try:
        token = request.GET.get('token')
        email = request.GET.get('email')
        invest = int(request.GET.get('invest'))
        try:
            email_Check = User.objects.get(email=email)

            # user_info = Client.objects.filter(user=email_Check)
            offer_obj = Client_Investment.objects.get(id=invest)

            if offer_obj.payment_token == token:

                client_offer = Client_Investment.objects.get(id=invest)
                client_offer.approved = True
                client_offer.status = 'Complete'
                client_offer.save()

                messages.success(request, 'You have successfully Approve this request, You can Check Here')

                return redirect(reverse('accounts:login'))
            else:
                messages.error(request, 'Invalid Payment Token,please try again')
                return redirect(reverse('accounts:login'))

        except User.DoesNotExist:
            traceback.print_exc()
            messages.error(request, "Invalid Informations, please try again")
            return redirect(reverse('accounts:login'))
    except:
        traceback.print_exc()
        messages.error(request, "Invalid Informations, please try again")
        return redirect(reverse('accounts:login'))

payment/templates/payment/approval.html
{% load static %}
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
   <head>
      <title>Email</title>
      <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
      <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=0">
      <link href="https://fonts.googleapis.com/css?family=Roboto:300,400,500,700,900" rel="stylesheet">
      <!--  General CSS  -->
      <style type="text/css">
         html{
         width: 100%; 
         }
         body{
         width: 100%;  
         margin:0; 
         padding:0; 
         -webkit-font-smoothing: antialiased;
         mso-margin-top-alt:0px; 
         mso-margin-bottom-alt:0px; 
         mso-padding-alt: 0px 0px 0px 0px;
         background: #E7E7E7;
         }
         p,h1,h2,h3,h4{
         margin-top:0;
         margin-bottom:0;
         padding-top:0;
         padding-bottom:0;
         }
         table{
         font-size: 14px;
         border: 0;
         }
         img{
         border: none!important;
         }
         span {
         color: #ff3d00;
         }
      </style>
      <!--  Responsive CSS  -->
      <style type="text/css">
         @media only screen and (max-width: 800px) {
         body[yahoo] .quote_full_width {width:100% !important;}
         body[yahoo] .quote_content_width {width:90% !important;}
         }
         @media only screen and (max-width: 640px) {
         body[yahoo] .full_width {width:100% !important;}
         body[yahoo] .content_width{width:80% !important;}
         body[yahoo] .center_txt {text-align: center!important;}
         body[yahoo] .post_sep {width:100% !important; height:60px !important;}
         body[yahoo] .gal_sep {width:100% !important; height:40px !important;}
         body[yahoo] .gal_img {width:100% !important;}
         body[yahoo] .bb_space {height:90px !important;}
         }  
      </style>
   </head>
   <body style="margin: 0; padding: 0;" yahoo="fix">
      <table border="0" cellpadding="0" cellspacing="0" width="100%" style="background: #f3f3f3;">
         <tr>
            <td>
               <table width="720" cellpadding="0" cellspacing="0" align="center" class="content_width"
                  style="border-collapse:collapse;text-align: center;background-color: #fff;border: 0;border: none;">
                  <tr>
                     <td height="30" width="100%">&nbsp;</td>
                  </tr>
                  <tr>
                     <td>
                        <h3 style="color: #818181;font-family: 'Raleway', Helvetica, Arial, sans-serif; font-size: 16px;   padding: 0px 15px; text-align: left;font-weight: 600;">
                           Hi Admin
                        </h3>
                        <br>
                        <p style="color: #818181;font-family: 'Raleway', Helvetica, Arial, sans-serif; font-size: 16px; padding: 0px 15px; text-align: left;font-weight: 500; ">
                           You recently received a request From {{client_obj.user.username}} for verified his payment approval. Simply click on below link and user will got approval.
                        </p>
                        <br>
                     </td>
                  </tr>
                  <tr>
                     <td>
                        <div style="color: #55a245;font-family: 'Raleway', Helvetica, Arial, sans-serif; font-size:28px;padding: 0px 15px;text-align: center;font-weight:600;">
                           <a href="http://{{site_url}}/payment/payment_check/?token={{payment_token}}&email={{email}}&invest={{investoment_id}}"
                              style="background: #0a4a7f;padding:12px 24px;border: 0;color: #fff;line-height: 1;border-radius:5px;letter-spacing:1px; text-decoration: none;font-size: 18px; font-weight: normal;" target="_blank">Click Here To Approve Request</a>
                        </div>
                     </td>
                  </tr>
                  <tr>
                     <td height="50" width="100%">&nbsp;</td>
                  </tr>
                  <tr>
                     <td>
                        <table width="720" cellpadding="0" cellspacing="0" align="center"
                           class="content_width"
                           style="border-collapse:collapse; mso-table-lspace:0pt; mso-table-rspace:0pt;background: #fdfdfd;border-top: 1px dashed #ddd;">
                           <tr>
                              <td>
                                 <table width="720" align="center" border="0" cellpadding="0" cellspacing="0"
                                    style="border-collapse:collapse; mso-table-lspace:0pt; mso-table-rspace:0pt; border-top: 1px dashed #ddd;"
                                    class="content_width">
                                    <tr>
                                       <td style="background: #ffffff;" width="100%" height="20"></td>
                                    </tr>
                                    <tr>
                                       <td style="background: #ffffff;">
                                          <table width="100%" align="canter" border="0" cellpadding="0"
                                             cellspacing="0"
                                             style="border-collapse:collapse; mso-table-lspace:0pt; mso-table-rspace:0pt;"
                                             class="full_width center_txt">
                                             <tr>
                                                <td style="color: #000; font-family: 'Raleway', Helvetica, Arial, sans-serif; font-size: 17px; letter-spacing:.5px; font-weight: 500;text-align: center;">
                                                </td>
                                             </tr>
                                          </table>
                                       </td>
                                    </tr>
                                    <tr>
                                       <td style="background: #ffffff;" width="100%" height="20"></td>
                                    </tr>
                                 </table>
                              </td>
                           </tr>
                        </table>
                     </td>
                  </tr>
               </table>
            </td>
         </tr>
      </table>
   </body>
</html>

payment/templates/payment/credit_card.html
{% extends 'base/base.html' %}
{% load static %}
{% block title %}
<title>Payment - Solomartel</title>
{% endblock title %}
{% block content %}
<style type="text/css">
   .form-control.has-error {
   border: 1px solid #FB404B !important;
   color: #FB404B !important;
   }
   .form-control.has-success {
   border: 1px solid #28a745 !important;
   color: #28a745 !important;
   }
   .error-msg {
   color: red;
   font-size: 13px;
   margin: 3px;
   }
</style>
<link rel="stylesheet" href="{% static 'css/new_style.css' %}" id="main-styles-link">
<section class=" container section novi-background" style="padding-top: 75px;">
    <h4 style="margin-top: 0px">Credit Card</h4>

    {% if message %}
    <br>
    <div class="alert alert-danger" id="msg">{{message}}</div>
    {% endif %}
    <div role="form" class="wpcf7 p-4" id="wpcf7-f8293-p8709-o4" lang="en-US" dir="ltr">
        <div class="screen-reader-response"></div>
        <form action="{% url 'payment:charge' id_offer_obj %}" method="POST"
              id="credit_card_form" class="wpcf7-form">
            {% csrf_token %}
            <div class="row justify-content-center">
                <div class="col-xs-12 col-sm-12">
                    <div class="form-group">
                        <strong><label>Card Number </label></strong><br>
                        <span class="wpcf7-form-control-wrap propertyname"><input
                                type="text" name="creditcardnumber"
                                id="creditcardnumber_number" maxlength="19"
                                placeholder="XXXX XXXX XXXX XXXX"
                                class="wpcf7-form-control wpcf7-text wpcf7-validates-as-required form-control "
                                onkeypress="CreditCardNumber()"></span>
                    </div>
                </div>
                <div class="col-xs-6 col-sm-6">
                    <div class="form-group">
                        <strong><label>Expiry (MM/YY) </label></strong><br>
                        <span class="wpcf7-form-control-wrap investmentamount"><input
                                type="expiry" name="month_year"
                                maxlength="5"
                                id="checkexpiry"
                                class="wpcf7-form-control wpcf7-number wpcf7-validates-as-required wpcf7-validates-as-number form-control"
                                onkeypress="ExpiaryDateCheck()"
                                placeholder="MM/YY"></span>
                    </div>
                </div>
                <div class="col-xs-6 col-sm-6">
                    <div class="form-group">
                        <strong><label>Card Code</label></strong><br>
                        <span class="wpcf7-form-control-wrap investmentamount"><input
                                type="name" name="cardcode"
                                id="cardcode"
                                class="wpcf7-form-control wpcf7-number wpcf7-validates-as-required wpcf7-validates-as-number form-control"
                                maxlength="3"
                                placeholder="CVV"></span>
                    </div>
                </div>
                <div class="col-xs-12 col-sm-12">
                    <div class="form-group">
                        <strong><label>Amount(in USD) </label></strong><br>
                        <span class="wpcf7-form-control-wrap phonenumber"><input
                                type="number" name="amount_entered" size="40"
                                value={{ obj_invest.invested_amount }}
                                id="inveted_Amount"
                                class="wpcf7-form-control wpcf7-text wpcf7-validates-as-required form-control" readonly></span>
                    </div>
                </div>
                <div class="col-xs-10 col-sm-10 text-center">
                    <br>
                    <input type="submit" value="Invest"
                           class="btn text-white" style="background-color: #0a4a7f !important;"><span
                        class="ajax-loader"></span>
                </div>
            </div>
        </form>
        <h4 class="text-center">Use Another Payment Method</h4>
        <div class="row justify-content-center">
            <br>
            <a href="#">
                <input type="button" style="background-color: #0a4a7f !important;"
                       value="Go Back"
                       class="btn text-white"></a>
        </div>
    </div>
</section>
<script src="https://js.stripe.com/v3/"></script>
{% endblock content %}

payment/templates/payment/thankyou.html
{% extends 'base/base.html' %}
{% load static %}

{% block title %}
<title>Transactions - Solomartel </title>
{% endblock title %}
{% block content %}
<!-- Breadcrumbs -->

<div class="breadcrumbs-custom-inner"><br>
    <div class="row justify-content-center alert alert-success text-center" id="msg">
        <h3>Thank you for your completed all your steps,Your request is being processed,we will contact you
            shortly </h3>
        <p>Reviewing Your Request</p>
    </div>
</div>

{% endblock content %}